
// The D/Objective-C Bridge
// Copyright © 2007  Michel Fortin
// <http://michelf.com/d-objc-bridge/>
//
// This program is free software: you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free 
// Software Foundation, either version 3 of the License, or (at your option) 
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT 
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
// more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program. If not, see <http://www.gnu.org/licenses/>.

module cocoa.appkit.alert;

import cocoa.foundation.object;
import cocoa.foundation.string;

import objc.bridge;


class NSAlert : NSObject {
	mixin ObjcWrap;
	this(objc.runtime.id self) { super(self); }

	static NSAlert alert(NSString message, NSString defaultButton, NSString alternateButton, NSString otherButton, NSString informativeText) {
		return invokeObjcSuperClass!(NSAlert, "alertWithMessageText:defaultButton:alternateButton:otherButton:informativeTextWithFormat:")(message, defaultButton, alternateButton, otherButton, informativeText);
	}
	
	static NSAlert alert(char[] message, char[] defaultButton, char[] alternateButton, char[] otherButton, char[] informativeText) {
		return alert(message.toNSString(), defaultButton.toNSString(), alternateButton.toNSString(), otherButton.toNSString(), informativeText.toNSString());
	}


	int runModal() {
		return invokeObjcSuper!(int, "runModal")();
	}
	mixin ObjcBindMethod!(runModal, int, "runModal");
	
}