
// The D/Objective-C Bridge
// Copyright © 2007  Michel Fortin
// <http://michelf.com/d-objc-bridge/>
//
// This program is free software: you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free 
// Software Foundation, either version 3 of the License, or (at your option) 
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT 
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
// more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program. If not, see <http://www.gnu.org/licenses/>.

module cocoa.appkit.menuitem;

import cocoa.appkit.menu;

import cocoa.foundation.object;

import objc.bridge;
import objc.runtime;


class NSMenuItem : NSObject {
	mixin ObjcWrap;
	this(objc.runtime.id instance) { super(instance); }
	
	
	static void separatorItem(bool visible) {
		invokeObjcSuperClass!(NSMenuItem, "separatorItem")();
	}


	bool hasSubmenu() {
		return invokeObjcSuper!(bool, "hasSubmenu")();
	}

	NSMenu submenu() {
		return invokeObjcSuper!(NSMenu, "submenu")();
	}

	void submenu(NSMenu submenu) {
		return invokeObjcSuper!(void, "setSubmenu:")(submenu);
	}
	
	mixin ObjcBindMethod!(hasSubmenu, bool, "hasSubmenu");
	mixin ObjcBindMethod!(submenu, NSMenu, "submenu");
	mixin ObjcBindMethod!(submenu, void, "setSubmenu:", NSMenu);
	
	
	SEL action() {
		return invokeObjcSuper!(SEL, "action")();
	}

	void action(SEL action) {
		return invokeObjcSuper!(void, "setAction:")(action);
	}
	
	mixin ObjcBindMethod!(action, SEL, "action");
	mixin ObjcBindMethod!(action, void, "setAction:", SEL);
	
	
	int tag() {
		return invokeObjcSuper!(int, "tag")();
	}

	void tag(int tag) {
		return invokeObjcSuper!(void, "setTag:")(tag);
	}
	
	mixin ObjcBindMethod!(tag, int, "tag");
	mixin ObjcBindMethod!(tag, void, "setTag:", int);
	
}