
// The D/Objective-C Bridge
// Copyright © 2007  Michel Fortin
// <http://michelf.com/d-objc-bridge/>
//
// This program is free software: you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free 
// Software Foundation, either version 3 of the License, or (at your option) 
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT 
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
// more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program. If not, see <http://www.gnu.org/licenses/>.

module cocoa.foundation.zone;

import cocoa.foundation.object;
import cocoa.foundation.string;

private struct _NSZone { }
alias _NSZone NSZone;

extern (C) {

	NSZone* NSDefaultMallocZone();
	NSZone* NSCreateZone(uint startSize, uint granularity, byte canFree);
	void NSRecycleZone(NSZone* zone);
	void NSSetZoneName(NSZone* zone, NSString name);
	NSString NSZoneName(NSZone* zone);
	NSZone NSZoneFromPointer(void* ptr);

	void* NSZoneMalloc(NSZone* zone, uint size);
	void* NSZoneCalloc(NSZone* zone, uint numElems, uint byteSize);
	void* NSZoneRealloc(NSZone* zone, void* ptr, uint size);
	void NSZoneFree(NSZone* zone, void* ptr);

	enum {
		NSScannedOption = (1<<0)
	}

	version (AVAILABLE_MAC_OS_X_VERSION_10_4_AND_LATER)
	void* NSAllocateCollectable(uint size, uint options);
	
	version (AVAILABLE_MAC_OS_X_VERSION_10_4_AND_LATER)
	void* NSReallocateCollectable(void* ptr, uint size, uint options);

	uint NSPageSize();
	uint NSLogPageSize();
	uint NSRoundUpToMultipleOfPageSize(uint bytes);
	uint NSRoundDownToMultipleOfPageSize(uint bytes);
	void* NSAllocateMemoryPages(uint bytes);
	void NSDeallocateMemoryPages(void* ptr, uint bytes);
	void NSCopyMemoryPages(void* source, void* dest, uint bytes);
	uint NSRealMemoryAvailable();

}